unit DrBobXML;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  XMLBrokr, HTTPApp;

type
  TBXMLBroker = class(TXMLBroker)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function RequestRecords(Sender: TObject; Request: TWebRequest;
      out RecCount: Integer; var OwnerData: OleVariant;
      XMLOptions: TXMLOptions): string; override;
    function GetXMLRecords(var RecsOut: Integer; var OwnerData: OleVariant;
      XMLOptions: TXMLOptions): string;
  published
    { Published declarations }
  end;

procedure Register;

implementation
uses
  Provider, DsIntf, DBClient;

function TBXMLBroker.RequestRecords(Sender: TObject; Request: TWebRequest;
  out RecCount: Integer; var OwnerData: OleVariant;
  XMLOptions: TXMLOptions): string;
begin
  Result := '';
  if Assigned(OnRequestRecords) then
    OnRequestRecords(Sender, Request, RecCount, OwnerData, Result);
  if Result = '' then
    Result := GetXMLRecords(RecCount, OwnerData, XMLOptions);
end;

function TBXMLBroker.GetXMLRecords(
  var RecsOut: Integer; var OwnerData: OleVariant;
  XMLOptions: TXMLOptions): string;
var
  ByteArray: OleVariant;
  Options: TGetRecordOptions;
begin
  // Don't reset
  // Options := [grMetaData, grXML, grReset];
  Options := [grMetaData, grXML];
  RecsOut := 0;
  ByteArray := AS_GetRecords(MaxRecords, RecsOut, Byte(Options), '', PackageParams(Params), OwnerData);
  Result := FormatXML(VariantArrayToString(ByteArray),
     XMLOptions);
end;

procedure Register;
begin
  RegisterComponents('DrBob42', [TBXMLBroker]);
end;

end.
