unit Unit3;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Grids, DBGrids, Db, DBClient, MConnect, StdCtrls,
  SConnect, ObjBrkr;

type
  TForm3 = class(TForm)
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Button6: TButton;
    ClientDataSet2: TClientDataSet;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    ClientDataSet1CustNo: TFloatField;
    ClientDataSet1Company: TStringField;
    ClientDataSet1City: TStringField;
    ClientDataSet1LastInvoiceDate: TDateTimeField;
    ClientDataSet1TableOrders: TDataSetField;
    Button7: TButton;
    Button8: TButton;
    SocketConnection1: TSocketConnection;
    WebConnection1: TWebConnection;
    SimpleObjectBroker1: TSimpleObjectBroker;
    Button9: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ClientDataSet1ReconcileError(DataSet: TClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure Button6Click(Sender: TObject);
    procedure ClientDataSet1BeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
    procedure Button7Click(Sender: TObject);
    procedure ClientDataSet1AfterGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation
uses
  RecError;
{$R *.DFM}

procedure TForm3.Button1Click(Sender: TObject);
begin
  if (Sender AS TButton).Caption = 'Connect' then
  begin
    ClientDataSet1.Active := True;
    ClientDataSet2.Active := True;
    (Sender AS TButton).Caption := 'Disconnect';
  end
  else // Disconnect
  begin
    ClientDataSet2.Active := False;
    ClientDataSet1.Active := False;
    try
      SocketConnection1.Connected := False;
      WebConnection1.Connected := False;
    except
      on E: Exception do
      Caption := E.Message
    end;
//  DCOMConnection1.Connected := False;
    (Sender AS TButton).Caption := 'Connect';
  end
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  ClientDataSet1.SaveToFile('c:\dataset.cds');
end;

procedure TForm3.Button5Click(Sender: TObject);
begin
  ClientDataSet1.SaveToFile('c:\dataset.xml');
end;

procedure TForm3.Button3Click(Sender: TObject);
begin
  ClientDataSet1.MergeChangeLog;
  ClientDataSet1.LoadFromFile('c:\dataset.xml'); // .cds
  ClientDataSet2.Active := True;
end;

procedure TForm3.Button4Click(Sender: TObject);
begin
 ClientDataSet1.ApplyUpdates(-1);
end;

procedure TForm3.ClientDataSet1ReconcileError(DataSet: TClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(DataSet, UpdateKind, E);
end;

procedure TForm3.Button6Click(Sender: TObject);
begin
  ClientDataSet1.Active := False;
  ClientDataSet1.CommandText := Edit1.Text;
  ClientDataSet1.Active := True;
end;

procedure TForm3.ClientDataSet1BeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
var
  Bookmark: TBookMark;
  AC: TClientDataSet;
begin
{
  AC := (Sender AS TClientDataSet);
  if AC.Active then
  try
    Bookmark := (Sender AS TClientDataSet).GetBookmark;
    (Sender AS TClientDataSet).Last;
    OwnerData := (Sender AS TClientDataSet).
      FieldByName('custno').AsString;
  finally
    (Sender AS TClientDataSet).GotoBookmark(Bookmark);
    (Sender AS TClientDataSet).FreeBookmark(Bookmark)
  end
}
end;

procedure TForm3.Button7Click(Sender: TObject);
begin
  ClientDataSet1.GetNextPacket
end;

procedure TForm3.ClientDataSet1AfterGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
var
  Str: String;
begin
  Str := OwnerDAta;
  if Str <> ''then Caption := Str;
end;

procedure TForm3.Button8Click(Sender: TObject);
begin
  ClientDataSet1.MergeChangeLog;
end;

procedure TForm3.Button9Click(Sender: TObject);
begin
  SocketCOnnection1.Connected := False;
  WebConnection1.Connected := False;
end;

end.
